Link to the quickstart page.
[wiki.git] / doc / cpan.mdwn
index fb6a9712fe956aa69de48ad9e4a5c31f7a808ba0..662281cc0df22a8f44bfb73fd61b2e941e928277 100644 (file)
@@ -26,7 +26,7 @@ You should now be able to install a package with `install Package`.
 
 If you don't have root access, just want to install packages for your own use, or want to install packages into AFS for use from multiple systems, you want [`local::lib`][local::lib]. (It's possible to configure CPAN to do this by hand, but trust me, `local::lib` is easier).
 
- * Grab the latest `local::lib` tarball from CPAN (As of this writing, that's version [1.4.9][lltgz])
+ * Grab the latest `local::lib` tarball from CPAN (As of this writing, that's version [1.008004][lltgz])
  * Unpack the tarball and run
 
         perl Makefile.PL --bootstrap=/path/to/install/
@@ -36,18 +36,31 @@ You can now run `perl -I/path/to/install/lib/perl5/ -Mlocal::lib` to get a fragm
 
 For more details, such as how to manage multiple different `local::lib` installations, see `local::lib`'s [documentation on CPAN][local::lib]
 
-[local::lib]: http://search.cpan.org/~apeiron/local-lib-1.004009/lib/local/lib.pm "local::lib"
-[lltgz]: http://search.cpan.org/CPAN/authors/id/A/AP/APEIRON/local-lib-1.004009.tar.gz
+[local::lib]: http://search.cpan.org/perldoc?local::lib "local::lib"
+[lltgz]: http://www.cpan.org/modules/by-module/lib/local-lib-1.008004.tar.gz
 
 ## Automatically installing dependencies
 
 By default, CPAN prompts you whether or not to follow dependencies when installing a package. This is not usually what you want -- if you want a specific package, you don't care what CPAN has to install to get it to you, so it should do so automatically. There are two steps required to get CPAN to do this:
 
- * Set `prerequisites_policy` to `follow` inside CPAN (`o conf prerequisites_policy follow` and then `o conf commit`)
+ * Within the CPAN interactive shell (run `cpan`), Set `prerequisites_policy` to `follow` (`o conf prerequisites_policy follow` and then `o conf commit`)
  * Set the environment variable `PERL_MM_USE_DEFAULT` to `1`.
    e.g. run `cpan` as
 
-   `env PERL_MM_USE_DEFAULT=1 cpan`
+       env PERL_MM_USE_DEFAULT=1 cpan
+
+
+## Gotchas using CPAN on Athena
+
+ * For whatever reason, perl believes itself to be smarter than your operating system by default, and checks permissions by looking at the permission bits on files, rather than using `access(2)`. (See [filetest][filetest] in the Perl docs.) Furthermore, when installing modules, CPAN checks to see if you have write permissions on the destination, and aborts if it doesn't think you do, without even trying. I have been unable to find a way to override either of these behaviors.
+
+  This is a problem in AFS for obvious reasons, since AFS does not use UNIX permissions. I happen to only need to install perl modules into lockers on which I am the owner; If you need to install things somewhere where the UNIX permission bits indicate you would not have access, you're out of luck as far as I can tell.
+
+ * Sharing a `local::lib` installation dir across multiple platforms is not recommended. While perl **does** include the architecture and sysname (e.g. `x86_64-linux-gnu-thread-multi/`) in the path when installing `.so` files for modules written in XS, it **does not** do the same for the version of Perl itself. So while you can share a single installation directory between 32- and 64-bit platforms, or between Linux and Solaris, all kinds of things will go wrong if you try to share it between a 32-bit perl 5.8 and a 32-bit perl 5.10 on the same platform.
+
+I work around this for BarnOwl by having completely separate perl module installs for every AFS sysname we support. This is painful to maintain, but I've found it to be the most reliable option.
+
+[filetest]: http://perldoc.perl.org/filetest.html
 
 
 ## Cheat-sheet
@@ -56,6 +69,7 @@ By default, CPAN prompts you whether or not to follow dependencies when installi
 ### Installing packages system-wide
 
     $ env PERL_MM_USE_DEFAULT=1 cpan
+    # Answer 'yes' if CPAN asks to configure itself automatically
     cpan> o conf make_install_make_command '/usr/bin/sudo /usr/bin/make'
     cpan> o conf mbuild_install_build_command '/usr/bin/sudo ./Build'
     cpan> o conf prerequisites_policy follow
@@ -63,13 +77,14 @@ By default, CPAN prompts you whether or not to follow dependencies when installi
     cpan> install Some::Module
 
 ### Installing packages into a directory
-    $ wget http://search.cpan.org/CPAN/authors/id/A/AP/APEIRON/local-lib-1.004009.tar.gz
-    $ tar xzf local-lib-1.004009.tar.gz
-    $ cd local-lib-1.004009/
+    $ wget http://www.cpan.org/modules/by-module/lib/local-lib-1.008004.tar.gz
+    $ tar xzf local-lib-1.008004.tar.gz
+    $ cd local-lib-1.008004/
     $ perl Makefile.PL --bootstrap=/install/dir/
     $ make && make install
     $ eval $(perl -I/install/dir/lib/perl5/ -Mlocal::lib)
     $ env PERL_MM_USE_DEFAULT=1 cpan
+    # Answer 'yes' if CPAN asks to configure itself automatically
     cpan> o conf prerequisites_policy follow
     cpan> o conf commit
     cpan> install Some::Module